#!/bin/sh

for n in "$@"; do case ${n%%=*} in
  data) _DATA="${n#data=}";;
  exec) _exec="${n#exec=}";;
  noerr) exec 2>&-;;
esac; done

[ -z "${_EXEC%/}" ] && _EXEC="$(realpath "${0%/*}")" || _EXEC="${_EXEC%/}"
[ -z "${_DATA%/}" ] && _DATA=. || _DATA="${_DATA%/}"

file_pattern='^.*\.(mov|ts|mpg|mpeg|mp4|m4v|avi|mkv|flv|sfv|wmv|ogm|ogv|webm|iso|rmvb)$'

. "$_EXEC/cgilite/cgilite.sh"

FILTER="$(GET f)"
SEARCH="$(GET s)"
ORDER="$(GET o |grep -m1 -axE 'Date|Name|Length' || printf Name)"
LISTSIZE="$(COOKIE pagesize |grep -m1 -axE '[1-9][0-9]*' || printf 50)"
ITEM="$(PATH "${PATH_INFO#/}")"
ACTION="$(GET a)"

case $ACTION in
  setprefs)
    SET_COOKIE +$((86400 * 90)) pagesize="$(POST pagesize |grep -m1 -axE '[1-9][0-9]*' || printf 50)"
    SET_COOKIE +$((86400 * 90))     mode="$(POST     mode |grep -m1 -axE 'browse|index' || printf browse)"
    SET_COOKIE +$((86400 * 90))  fakemp4="$(POST  fakemp4 |grep -m1 -axE 'yes' || printf no)"
    REDIRECT "$(POST ref)"
  ;;
  bookmark)
    bm="$_DATA/.index/bookmarks"
    . "$_EXEC/cgilite/storage.sh"

    s="$(POST search |STRING)"; f="$(POST filter |STRING)"
    if LOCK "$bm"; then
      grep -avF "	search=$s	filter=$f${CR}" "$bm" >"$bm.tmp"
      [ ! "$(POST delete)" ] \
      && printf '%s	search=%s	filter=%s\r\n' \
	        "$(POST name |STRING)" "$s" "$f" >>"$bm.tmp"
      mv "$bm.tmp" "$bm"
      RELEASE "$bm"
    fi
    REDIRECT "$(POST ref)"
  ;;
esac

if [ "$ITEM" = "/style.css" ]; then
  . "$_EXEC/cgilite/file.sh"
  [ -r "$_DATA/$ITEM" ] && FILE "$_DATA/$ITEM" \
                        || FILE "$_EXEC/style.css"
elif [ -f "$_DATA/$ITEM" ]; then
  case $ACTION in
    tag)
    ;;
    thumbnail)
      . "$_EXEC/cgilite/file.sh"
      index="$_DATA/${ITEM%/*}/.index"
      thumb="$index/${ITEM##*/}"; thumb="${thumb%.*}.jpg"
      [ -d "$index" -a \! -f "$thumb" ] \
      && file="$_DATA/$ITEM" . "$_EXEC/thumbnail.sh"
      FILE "$thumb"
    ;;
    delete)
    ;;
    *) . "$_EXEC/cgilite/file.sh"
      fakemp4="$(COOKIE fakemp4)"
      FILE "$_DATA/$ITEM" "$([ "$fakemp4" = yes ] && printf 'video/mp4')"
    ;;
  esac
elif [ -d "$_DATA/$ITEM" ]; then
  case $ACTION in
    advsearch)
      . "$_EXEC/advsearch.sh"
    ;;
    multitag)
      if [ "$(POST spawn)" = spawn ]; then
        case "$(POST recursive)" in
          yes) find "$_DATA/$ITEM" \
                    -depth -type d \! -name .index \
                    -exec mkdir -p '{}'/.index \;
          ;;
          *) mkdir -p "$_DATA/$ITEM/.index";;
        esac
      else
      . "$_EXEC/multitag.sh"
      fi
      REDIRECT "$(POST ref)"
    ;;
    *) . "$_EXEC/list.sh"
    ;;
  esac
else
  printf 'Status: 404 Not Found\r\nContent-Length 0:\r\n\r\n'
fi
